<!doctype html>
<html class="no-js" lang="">
    <head>
        <meta charset="utf-8">
        <meta http-equiv="x-ua-compatible" content="ie=edge">
        <title>gateway documentation</title>
        <meta name="description" content="">
        <meta name="viewport" content="width=device-width, initial-scale=1">

        <link rel="icon" type="image/x-icon" href="../images/favicon.ico">
	      <link rel="stylesheet" href="../styles/style.css">
    </head>
    <body>

        <div class="navbar navbar-default navbar-fixed-top visible-xs">
            <a href="../" class="navbar-brand">gateway documentation</a>
            <button type="button" class="btn btn-default btn-menu ion-ios-menu" id="btn-menu"></button>
        </div>

        <div class="xs-menu menu" id="mobile-menu">
                <div id="book-search-input" role="search"><input type="text" placeholder="Type to search"></div>            <compodoc-menu></compodoc-menu>
        </div>

        <div class="container-fluid main">
           <div class="row main">
               <div class="hidden-xs menu">
                   <compodoc-menu mode="normal"></compodoc-menu>
               </div>
               <!-- START CONTENT -->
               <div class="content class">
                   <div class="content-data">











<ol class="breadcrumb">
  <li>Classes</li>
  <li>MongoDatabaseHandle</li>
</ol>

<ul class="nav nav-tabs" role="tablist">
        <li class="active">
            <a href="#info" role="tab" id="info-tab" data-toggle="tab" data-link="info">Info</a>
        </li>
        <li >
            <a href="#source" role="tab" id="source-tab" data-toggle="tab" data-link="source">Source</a>
        </li>
</ul>

<div class="tab-content">
    <div class="tab-pane fade active in" id="c-info">
        <p class="comment">
            <h3>File</h3>
        </p>
        <p class="comment">
            <code>src/database/mongodb/database.ts</code>
        </p>



            <p class="comment">
                <h3>Implements</h3>
            </p>
            <p class="comment">
                            <code><a href="../interfaces/IDatabase.html" target="_self" >IDatabase</a></code>
            </p>


            <section>
    <h3 id="index">Index</h3>
    <table class="table table-sm table-bordered index-table">
        <tbody>
                <tr>
                    <td class="col-md-4">
                        <h6><b>Properties</b></h6>
                    </td>
                </tr>
                <tr>
                    <td class="col-md-4">
                        <ul class="index-list">
                            <li>
                                    <span class="modifier">Private</span>
                                    <span class="modifier">Static</span>
                                <a href="#_client">_client</a>
                            </li>
                            <li>
                                    <span class="modifier">Private</span>
                                    <span class="modifier">Static</span>
                                <a href="#_connectionString">_connectionString</a>
                            </li>
                            <li>
                                    <span class="modifier">Private</span>
                                    <span class="modifier">Static</span>
                                <a href="#_options">_options</a>
                            </li>
                            <li>
                                    <span class="modifier">Private</span>
                                    <span class="modifier">Static</span>
                                <a href="#_store">_store</a>
                            </li>
                            <li>
                                    <span class="modifier">Private</span>
                                    <span class="modifier">Static</span>
                                    <span class="modifier">Readonly</span>
                                <a href="#logger">logger</a>
                            </li>
                        </ul>
                    </td>
                </tr>

                <tr>
                    <td class="col-md-4">
                        <h6><b>Methods</b></h6>
                    </td>
                </tr>
                <tr>
                    <td class="col-md-4">
                        <ul class="index-list">
                            <li>
                                    <span class="modifier">Static</span>
                                <a href="#checkIndex">checkIndex</a>
                            </li>
                            <li>
                                    <span class="modifier">Static</span>
                                <a href="#close">close</a>
                            </li>
                            <li>
                                    <span class="modifier">Static</span>
                                    <span class="modifier">Async</span>
                                <a href="#collection">collection</a>
                            </li>
                            <li>
                                    <span class="modifier">Static</span>
                                    <span class="modifier">Async</span>
                                <a href="#connect">connect</a>
                            </li>
                            <li>
                                    <span class="modifier">Static</span>
                                <a href="#setConnectionString">setConnectionString</a>
                            </li>
                            <li>
                                    <span class="modifier">Static</span>
                                    <span class="modifier">Async</span>
                                <a href="#setDatabase">setDatabase</a>
                            </li>
                            <li>
                                    <span class="modifier">Static</span>
                                    <span class="modifier">Async</span>
                                <a href="#store">store</a>
                            </li>
                        </ul>
                    </td>
                </tr>





        </tbody>
    </table>
</section>


            <section>
    
        <h3 id="inputs">
            Properties
        </h3>
        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
                        <a name="_client"></a>
                        <span class="name">
                            <b>
                                <span class="modifier">Private</span>
                                <span class="modifier">Static</span>
                            _client</b>
                            <a href="#_client"><span class="icon ion-ios-link"></span></a>
                        </span>
                    </td>
                </tr>
                    <tr>
                        <td class="col-md-4">
                            <i>Type : </i>    <code>MongoClient</code>

                        </td>
                    </tr>
                        <tr>
                            <td class="col-md-4">
                                    <div class="io-line">Defined in <a href="" data-line="63" class="link-to-prism">src/database/mongodb/database.ts:63</a></div>
                            </td>
                        </tr>


            </tbody>
        </table>
        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
                        <a name="_connectionString"></a>
                        <span class="name">
                            <b>
                                <span class="modifier">Private</span>
                                <span class="modifier">Static</span>
                            _connectionString</b>
                            <a href="#_connectionString"><span class="icon ion-ios-link"></span></a>
                        </span>
                    </td>
                </tr>
                    <tr>
                        <td class="col-md-4">
                            <i>Type : </i>        <code><a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/string" target="_blank" >string</a></code>

                        </td>
                    </tr>
                    <tr>
                        <td class="col-md-4">
                            <i>Default value : </i><code>&#x27;&#x27;</code>
                        </td>
                    </tr>
                        <tr>
                            <td class="col-md-4">
                                    <div class="io-line">Defined in <a href="" data-line="62" class="link-to-prism">src/database/mongodb/database.ts:62</a></div>
                            </td>
                        </tr>


            </tbody>
        </table>
        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
                        <a name="_options"></a>
                        <span class="name">
                            <b>
                                <span class="modifier">Private</span>
                                <span class="modifier">Static</span>
                            _options</b>
                            <a href="#_options"><span class="icon ion-ios-link"></span></a>
                        </span>
                    </td>
                </tr>
                    <tr>
                        <td class="col-md-4">
                            <i>Type : </i>    <code>MongoClientOptions</code>

                        </td>
                    </tr>
                    <tr>
                        <td class="col-md-4">
                            <i>Default value : </i><code>{
        useUnifiedTopology: true,
        useNewUrlParser: true,
        poolSize: 5
    }</code>
                        </td>
                    </tr>
                        <tr>
                            <td class="col-md-4">
                                    <div class="io-line">Defined in <a href="" data-line="65" class="link-to-prism">src/database/mongodb/database.ts:65</a></div>
                            </td>
                        </tr>


            </tbody>
        </table>
        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
                        <a name="_store"></a>
                        <span class="name">
                            <b>
                                <span class="modifier">Private</span>
                                <span class="modifier">Static</span>
                            _store</b>
                            <a href="#_store"><span class="icon ion-ios-link"></span></a>
                        </span>
                    </td>
                </tr>
                    <tr>
                        <td class="col-md-4">
                            <i>Type : </i>    <code>Db</code>

                        </td>
                    </tr>
                        <tr>
                            <td class="col-md-4">
                                    <div class="io-line">Defined in <a href="" data-line="64" class="link-to-prism">src/database/mongodb/database.ts:64</a></div>
                            </td>
                        </tr>


            </tbody>
        </table>
        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
                        <a name="logger"></a>
                        <span class="name">
                            <b>
                                <span class="modifier">Private</span>
                                <span class="modifier">Static</span>
                                <span class="modifier">Readonly</span>
                            logger</b>
                            <a href="#logger"><span class="icon ion-ios-link"></span></a>
                        </span>
                    </td>
                </tr>
                    <tr>
                        <td class="col-md-4">
                            <i>Default value : </i><code>new Logger(&#x27;Mongo Database&#x27;)</code>
                        </td>
                    </tr>
                        <tr>
                            <td class="col-md-4">
                                    <div class="io-line">Defined in <a href="" data-line="61" class="link-to-prism">src/database/mongodb/database.ts:61</a></div>
                            </td>
                        </tr>


            </tbody>
        </table>
</section>

            <section>
    
    <h3 id="methods">
        Methods
    </h3>
    <table class="table table-sm table-bordered">
        <tbody>
            <tr>
                <td class="col-md-4">
                    <a name="checkIndex"></a>
                    <span class="name">
                        <b>
                            <span class="modifier">Static</span>
                            checkIndex
                        </b>
                        <a href="#checkIndex"><span class="icon ion-ios-link"></span></a>
                    </span>
                </td>
            </tr>
            <tr>
                <td class="col-md-4">
                    <span class="modifier-icon icon ion-ios-reset"></span>
                    <code>checkIndex()</code>
                </td>
            </tr>


            <tr>
                <td class="col-md-4">
                    <div class="io-line">Defined in <a href="" data-line="158"
                            class="link-to-prism">src/database/mongodb/database.ts:158</a></div>
                </td>
            </tr>


            <tr>
                <td class="col-md-4">
                    <div class="io-description"><p>TEXT_INDEXES: Text indexes get a name of fieldA_text_fieldB_text
where fieldA and fieldB are two different fields. 
If there are only fieldA, then the name would be fieldA_text
<a href="https://docs.mongodb.com/manual/indexes/">https://docs.mongodb.com/manual/indexes/</a></p>
<p>ASC_DESC_INDEXES: fieldA_1_fieldB_-1
Here fieldA has a ascending index and fieldB a descending index</p>
</div>

                    <div class="io-description">
                        <b>Returns : </b>        <code><a href="https://www.typescriptlang.org/docs/handbook/basic-types.html" target="_blank" >void</a></code>

                    </div>
                </td>
            </tr>
        </tbody>
    </table>
    <table class="table table-sm table-bordered">
        <tbody>
            <tr>
                <td class="col-md-4">
                    <a name="close"></a>
                    <span class="name">
                        <b>
                            <span class="modifier">Static</span>
                            close
                        </b>
                        <a href="#close"><span class="icon ion-ios-link"></span></a>
                    </span>
                </td>
            </tr>
            <tr>
                <td class="col-md-4">
                    <span class="modifier-icon icon ion-ios-reset"></span>
                    <code>close()</code>
                </td>
            </tr>


            <tr>
                <td class="col-md-4">
                    <div class="io-line">Defined in <a href="" data-line="133"
                            class="link-to-prism">src/database/mongodb/database.ts:133</a></div>
                </td>
            </tr>


            <tr>
                <td class="col-md-4">
                    <div class="io-description"><p>Closes the database connection </p>
</div>

                    <div class="io-description">
                        <b>Returns : </b>        <code><a href="https://www.typescriptlang.org/docs/handbook/basic-types.html" target="_blank" >void</a></code>

                    </div>
                </td>
            </tr>
        </tbody>
    </table>
    <table class="table table-sm table-bordered">
        <tbody>
            <tr>
                <td class="col-md-4">
                    <a name="collection"></a>
                    <span class="name">
                        <b>
                            <span class="modifier">Static</span>
                            <span class="modifier">Async</span>
                            collection
                        </b>
                        <a href="#collection"><span class="icon ion-ios-link"></span></a>
                    </span>
                </td>
            </tr>
            <tr>
                <td class="col-md-4">
                    <span class="modifier-icon icon ion-ios-reset"></span>
                    <code>collection(collection: K)</code>
                </td>
            </tr>


            <tr>
                <td class="col-md-4">
                    <div class="io-line">Defined in <a href="" data-line="109"
                            class="link-to-prism">src/database/mongodb/database.ts:109</a></div>
                </td>
            </tr>

            <tr>
                <td class="col-md-4">
                    <b>Type parameters :</b>
                    <ul class="type-parameters">
                        <li>T</li>
                        <li>K</li>
                    </ul>
                </td>
            </tr>

            <tr>
                <td class="col-md-4">

                    <div class="io-description">
                        <b>Parameters :</b>
                        <table class="params">
                            <thead>
                                <tr>
                                    <td>Name</td>
                                    <td>Type</td>
                                    <td>Optional</td>
                                </tr>
                            </thead>
                            <tbody>
                                <tr>
                                    <td>collection</td>
                                    <td>
                                            <code>K</code>
                                    </td>

                                    <td>
                                        No
                                    </td>


                                </tr>
                            </tbody>
                        </table>
                    </div>
                    <div>
                    </div>
                    <div class="io-description">
                        <b>Returns : </b>    <code>{}</code>

                    </div>
                    <div class="io-description">
                        
                    </div>
                </td>
            </tr>
        </tbody>
    </table>
    <table class="table table-sm table-bordered">
        <tbody>
            <tr>
                <td class="col-md-4">
                    <a name="connect"></a>
                    <span class="name">
                        <b>
                            <span class="modifier">Static</span>
                            <span class="modifier">Async</span>
                            connect
                        </b>
                        <a href="#connect"><span class="icon ion-ios-link"></span></a>
                    </span>
                </td>
            </tr>
            <tr>
                <td class="col-md-4">
                    <span class="modifier-icon icon ion-ios-reset"></span>
                    <code>connect(dbName: <a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/string" target="_blank">string</a>)</code>
                </td>
            </tr>


            <tr>
                <td class="col-md-4">
                    <div class="io-line">Defined in <a href="" data-line="84"
                            class="link-to-prism">src/database/mongodb/database.ts:84</a></div>
                </td>
            </tr>


            <tr>
                <td class="col-md-4">
                    <div class="io-description"><p>Connects to a mongodb instance</p>
</div>

                    <div class="io-description">
                        <b>Parameters :</b>
                        <table class="params">
                            <thead>
                                <tr>
                                    <td>Name</td>
                                    <td>Type</td>
                                    <td>Optional</td>
                                    <td>Default value</td>
                                    <td>Description</td>
                                </tr>
                            </thead>
                            <tbody>
                                <tr>
                                    <td>dbName</td>
                                    <td>
                                                <code><a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/string" target="_blank" >string</a></code>
                                    </td>

                                    <td>
                                        No
                                    </td>

                                    <td>
                                        <code>&#x27;roamr-social&#x27;</code>
                                    </td>

                                    <td>
                                        <p>Name of the database to connect to</p>

                                    </td>
                                </tr>
                            </tbody>
                        </table>
                    </div>
                    <div>
                    </div>
                    <div class="io-description">
                        <b>Returns : </b>        <code><a href="https://www.typescriptlang.org/docs/handbook/basic-types.html" target="_blank" >any</a></code>

                    </div>
                    <div class="io-description">
                        
                    </div>
                </td>
            </tr>
        </tbody>
    </table>
    <table class="table table-sm table-bordered">
        <tbody>
            <tr>
                <td class="col-md-4">
                    <a name="setConnectionString"></a>
                    <span class="name">
                        <b>
                            <span class="modifier">Static</span>
                            setConnectionString
                        </b>
                        <a href="#setConnectionString"><span class="icon ion-ios-link"></span></a>
                    </span>
                </td>
            </tr>
            <tr>
                <td class="col-md-4">
                    <span class="modifier-icon icon ion-ios-reset"></span>
                    <code>setConnectionString(connectionString: <a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/string" target="_blank">string</a>)</code>
                </td>
            </tr>


            <tr>
                <td class="col-md-4">
                    <div class="io-line">Defined in <a href="" data-line="144"
                            class="link-to-prism">src/database/mongodb/database.ts:144</a></div>
                </td>
            </tr>


            <tr>
                <td class="col-md-4">
                    <div class="io-description"><p>Sets the connection string for the database</p>
</div>

                    <div class="io-description">
                        <b>Parameters :</b>
                        <table class="params">
                            <thead>
                                <tr>
                                    <td>Name</td>
                                    <td>Type</td>
                                    <td>Optional</td>
                                    <td>Description</td>
                                </tr>
                            </thead>
                            <tbody>
                                <tr>
                                    <td>connectionString</td>
                                    <td>
                                                <code><a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/string" target="_blank" >string</a></code>
                                    </td>

                                    <td>
                                        No
                                    </td>


                                    <td>
                                        <p>database connection string</p>

                                    </td>
                                </tr>
                            </tbody>
                        </table>
                    </div>
                    <div>
                    </div>
                    <div class="io-description">
                        <b>Returns : </b>        <code><a href="https://www.typescriptlang.org/docs/handbook/basic-types.html" target="_blank" >void</a></code>

                    </div>
                    <div class="io-description">
                        
                    </div>
                </td>
            </tr>
        </tbody>
    </table>
    <table class="table table-sm table-bordered">
        <tbody>
            <tr>
                <td class="col-md-4">
                    <a name="setDatabase"></a>
                    <span class="name">
                        <b>
                            <span class="modifier">Static</span>
                            <span class="modifier">Async</span>
                            setDatabase
                        </b>
                        <a href="#setDatabase"><span class="icon ion-ios-link"></span></a>
                    </span>
                </td>
            </tr>
            <tr>
                <td class="col-md-4">
                    <span class="modifier-icon icon ion-ios-reset"></span>
                    <code>setDatabase(dbName: <a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/string" target="_blank">string</a>)</code>
                </td>
            </tr>


            <tr>
                <td class="col-md-4">
                    <div class="io-line">Defined in <a href="" data-line="124"
                            class="link-to-prism">src/database/mongodb/database.ts:124</a></div>
                </td>
            </tr>


            <tr>
                <td class="col-md-4">

                    <div class="io-description">
                        <b>Parameters :</b>
                        <table class="params">
                            <thead>
                                <tr>
                                    <td>Name</td>
                                    <td>Type</td>
                                    <td>Optional</td>
                                    <td>Default value</td>
                                </tr>
                            </thead>
                            <tbody>
                                <tr>
                                    <td>dbName</td>
                                    <td>
                                                <code><a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/string" target="_blank" >string</a></code>
                                    </td>

                                    <td>
                                        No
                                    </td>

                                    <td>
                                        <code>&#x27;roamr&#x27;</code>
                                    </td>

                                </tr>
                            </tbody>
                        </table>
                    </div>
                    <div>
                    </div>
                    <div class="io-description">
                        <b>Returns : </b>        <code><a href="https://www.typescriptlang.org/docs/handbook/basic-types.html" target="_blank" >any</a></code>

                    </div>
                    <div class="io-description">
                        
                    </div>
                </td>
            </tr>
        </tbody>
    </table>
    <table class="table table-sm table-bordered">
        <tbody>
            <tr>
                <td class="col-md-4">
                    <a name="store"></a>
                    <span class="name">
                        <b>
                            <span class="modifier">Static</span>
                            <span class="modifier">Async</span>
                            store
                        </b>
                        <a href="#store"><span class="icon ion-ios-link"></span></a>
                    </span>
                </td>
            </tr>
            <tr>
                <td class="col-md-4">
                    <span class="modifier-icon icon ion-ios-reset"></span>
                    <code>store()</code>
                </td>
            </tr>


            <tr>
                <td class="col-md-4">
                    <div class="io-line">Defined in <a href="" data-line="71"
                            class="link-to-prism">src/database/mongodb/database.ts:71</a></div>
                </td>
            </tr>


            <tr>
                <td class="col-md-4">

                    <div class="io-description">
                        <b>Returns : </b>    <code>{}</code>

                    </div>
                </td>
            </tr>
        </tbody>
    </table>
</section>





    </div>


    <div class="tab-pane fade  tab-source-code" id="c-source">
        <pre class="line-numbers compodoc-sourcecode"><code class="language-typescript">import { MongoClient, Db, MongoClientOptions } from &quot;mongodb&quot;
import { Logger } from &quot;@nestjs/common&quot;
import { DatabaseModels, IDatabaseModels, ITextIndexMap } from &quot;.&quot;;
// import { IUserFireEntity, IPinEntity, IBusinessFireEntity, IBusinessMongoEntity, IUserMongoEntity, IPostEntity } from &quot;./models&quot;
// import { IMunicipalityMongoEntity } from &quot;./models/world/municipality&quot;
// import { IZoneMongoEntity } from &quot;./models/world/zone&quot;
// import { IMapboxRequestEntity } from &quot;./models/world/mapbox/mapbox-request&quot;
// import { IAreaMongoEntity } from &quot;./models/world/area&quot;
// import { ITrailMongoEntity } from &quot;./models/world/trail&quot;
// import { CountryTypes } from &quot;./models/world/world&quot;
// import { ISubscriptionMongo } from &quot;./models/products/subscriptions/subscription&quot;
// import { ICustomerEntity } from &quot;./models/products/customer/customer&quot;
// import { ISocialEventEntity } from &quot;./models/social/events/social-events&quot;
// import { IFollowingEntity } from &quot;./models/social/social-data/following/following&quot;
// import { IReactionEntity } from &quot;./models/social/social-data/reactions/reactions&quot;
// import { ICommentThreadEntity } from &quot;./models/social/social-data/comments/comment&quot;
// import { ISupportTicketEntity } from &quot;./models/substructure/support/support&quot;

//https://blog.mlab.com/2017/05/mongodb-connection-pooling-for-express-applications/
//https://fullstack-developer.academy/sharing-a-mongodb-connection-in-node-js-express/

// Remember to whitelist new computers or servers IP-adresses when deploying to a new server or starting to develop on a new computer

// function getCollectionByCountry(
//     collection_type: GenericDatabaseModels,
//     country: CountryTypes &#x3D; &#x27;sweden&#x27;
// ) {
//     switch (collection_type) {
//         case GenericDatabaseModels.MUNICIPALITIES:
//             switch (country) {
//                 case &#x27;sweden&#x27;:
//                     return DatabaseModels.SE_MUNICIPALITIES
//                 default:
//                     return DatabaseModels.SE_MUNICIPALITIES
//             }

//         case GenericDatabaseModels.PINS:
//             switch (country) {
//                 case &#x27;sweden&#x27;:
//                     return DatabaseModels.SE_PINS

//                 default:
//                     return DatabaseModels.SE_PINS
//             }

//         case GenericDatabaseModels.ZONES:
//             switch (country) {
//                 case &#x27;sweden&#x27;:
//                     return DatabaseModels.SE_ZONES
//                 default:
//                     return DatabaseModels.SE_ZONES
//             }
//     }
// }

export interface IDatabase {
    // connectionString: string
}

export class MongoDatabaseHandle implements IDatabase {
    private static readonly logger &#x3D; new Logger(&#x27;Mongo Database&#x27;)
    private static _connectionString: string &#x3D; &#x27;&#x27;
    private static _client: MongoClient
    private static _store: Db
    private static _options: MongoClientOptions &#x3D; {
        useUnifiedTopology: true,
        useNewUrlParser: true,
        poolSize: 5
    }

    static async store() {
        if (this._store !&#x3D;&#x3D; undefined) {
            return this._store
        } else {
            await this.connect()
            return this._store
        }
    }

    /**
     * Connects to a mongodb instance
     * @param dbName Name of the database to connect to
     */
    static async connect(dbName: string &#x3D; &#x27;roamr-social&#x27;) {
        try {
            if (this._client !&#x3D;&#x3D; undefined &amp;&amp;
                this._store !&#x3D;&#x3D; undefined) {
                // this.logger.debug(&#x27;Client should be defined&#x27;)
                // return this._store
            } else {
                this.logger.log(&#x27;Connecting to MongoDB&#x27;)
                this._client &#x3D; await MongoClient.connect(this._connectionString, this._options)
                this.setDatabase(dbName)
                // return this._store
                this.logger.log(&#x60;Connected to MongoDB: ${dbName}&#x60;)
            }

        } catch (error) {
            if (process.env.NODE_ENV !&#x3D;&#x3D; &#x27;production&#x27;) {
                this.logger.error(error)
            } else {
                this.logger.error(error)
            }

            // return null
        }
    }

    static async collection&lt;
        T extends IDatabaseModels,
        K extends keyof IDatabaseModels
    &gt;(collection: K) {
        try {
            await this.connect()
            return this._store.collection&lt;T[K]&gt;(collection)
        } catch (error) {
            console.log(&#x27;Failed getting collection&#x27;)
            console.log(error)
            this.logger.error(error)
            return null
        }
    }

    static async setDatabase(dbName: string &#x3D; &#x27;roamr&#x27;) {
        if (this._store &#x3D;&#x3D;&#x3D; undefined) {
            this._store &#x3D; this._client.db(dbName)
        }
    }

    /**
     * Closes the database connection 
     */
    static close() {
        if (this._client) {
            this._client.close()
            this.logger.log(&#x27;MongoDB connection closed&#x27;)
        }
    }

    /**
     * Sets the connection string for the database
     * @param connectionString database connection string
     */
    static setConnectionString(connectionString: string) {
        this.logger.log(&#x27;MongoDB connection has been set&#x27;)
        this._connectionString &#x3D; connectionString
    }

    /**
     * TEXT_INDEXES: Text indexes get a name of fieldA_text_fieldB_text
     * where fieldA and fieldB are two different fields. 
     * If there are only fieldA, then the name would be fieldA_text
     * https://docs.mongodb.com/manual/indexes/
     * 
     * ASC_DESC_INDEXES: fieldA_1_fieldB_-1
     * Here fieldA has a ascending index and fieldB a descending index
     */
    static checkIndex() {
        this.logger.debug(&#x27;Checking MongoDB indexes&#x27;)

        const textIndexes: ITextIndexMap[] &#x3D; [
            {
                collection: DatabaseModels.USERS,
                field: [
                    &#x27;username&#x27;,
                    &#x27;full_name&#x27;,
                ]
            }
        ]

        textIndexes.forEach(async f &#x3D;&gt; {
            try {
                let c &#x3D; await this.collection(f.collection)
                let index_name &#x3D;
                    f.field.reduce((acc, curr, idx) &#x3D;&gt; {
                        if (idx &#x3D;&#x3D;&#x3D; 0) {
                            return &#x60;${curr}_text&#x60;
                        } else {
                            return &#x60;${acc}_${curr}_text&#x60;
                        }
                    }, &#x27;&#x27;)
                let index_exists &#x3D; await c.indexExists(index_name)

                if (!index_exists) {
                    let field_spec &#x3D; f.field.reduce((acc, curr) &#x3D;&gt; {
                        return {
                            ...acc,
                            [curr]: &#x27;text&#x27;,
                        }
                    }, {})
                    let res &#x3D; await c.createIndex(field_spec)
                    this.logger.debug(&#x60;Created index: ${res}&#x60;)
                }
            } catch (error) {
                this.logger.error(error)
            }
        })
    }
}</code></pre>
    </div>
</div>



                   




                   </div><div class="search-results">
    <div class="has-results">
        <h1 class="search-results-title"><span class='search-results-count'></span> result-matching "<span class='search-query'></span>"</h1>
        <ul class="search-results-list"></ul>
    </div>
    <div class="no-results">
        <h1 class="search-results-title">No results matching "<span class='search-query'></span>"</h1>
    </div>
</div>
</div>
               <!-- END CONTENT -->
           </div>
       </div>

       <script>
            var COMPODOC_CURRENT_PAGE_DEPTH = 1;
            var COMPODOC_CURRENT_PAGE_CONTEXT = 'class';
            var COMPODOC_CURRENT_PAGE_URL = 'MongoDatabaseHandle.html';
            var MAX_SEARCH_RESULTS = 15;
       </script>

       <script src="../js/libs/custom-elements.min.js"></script>
       <script src="../js/libs/lit-html.js"></script>
       <!-- Required to polyfill modern browsers as code is ES5 for IE... -->
       <script src="../js/libs/custom-elements-es5-adapter.js" charset="utf-8" defer></script>
       <script src="../js/menu-wc.js" defer></script>

       <script src="../js/libs/bootstrap-native.js"></script>

       <script src="../js/libs/es6-shim.min.js"></script>
       <script src="../js/libs/EventDispatcher.js"></script>
       <script src="../js/libs/promise.min.js"></script>
       <script src="../js/libs/zepto.min.js"></script>

       <script src="../js/compodoc.js"></script>

       <script src="../js/tabs.js"></script>
       <script src="../js/menu.js"></script>
       <script src="../js/libs/clipboard.min.js"></script>
       <script src="../js/libs/prism.js"></script>
       <script src="../js/sourceCode.js"></script>
          <script src="../js/search/search.js"></script>
          <script src="../js/search/lunr.min.js"></script>
          <script src="../js/search/search-lunr.js"></script>
          <script src="../js/search/search_index.js"></script>
       <script src="../js/lazy-load-graphs.js"></script>


    </body>
</html>
